define(function (require) {
  // These are some comments I (Tom) left in from the require package.
  // Load any app-specific with a relative require call, like:
  // var messages = require('./messages');
  // Load library/vendor modules using full IDs, like:
  // var print = require('print');
  // print(messages.getHello());
  
  // Set some playback parameters and console.log the example Composition
  // object.
  var zoom_level = 1;
  
  // Define basic instrument.
  var expID = document.getElementById("expID");
  if (["1a", "1b", "2a", "2b"].indexOf(expID.value) > -1){
    // Run the local version.
    if (expID.value == "1a" || expID.value == "1b"){
      console.log('Local version of Haydn piano!');
      var piano_1 = require('piano_1_local').instrumentDescriptor();
    }
    else{
      console.log('Local version of Chopin piano. OK to load Haydn piano due to equal 95th percentile!');
      var piano_1 = require('piano_1_local').instrumentDescriptor();
    }
  }
  else {
    // Run the Dropbox version.
    if (expID.value == "3a" || expID.value == "3b"){
      console.log('Dropbox version of Haydn piano!');
      var piano_1 = require('piano_1_haydn').instrumentDescriptor();
    }
    else{
      console.log('Dropbox version of Chopin piano. OK to load Haydn piano due to equal 95th percentile!');
      var piano_1 = require('piano_1_haydn').instrumentDescriptor();
    }
  }
  
  
  console.log('piano_1:');
  console.log(piano_1);
  
  // Loop over the excerpts.
    
  //var c = {};
  //c.advanceOntimes = [];
  //c.advanceOnsets = [];
  //var rel_bpm = tonejs_scores[v.value].bpm;
  //for (i = 0; i < 30; i++){
  //  c.advanceOntimes.push(i/zoom_level);
  //  c.advanceOnsets.push(60*i/zoom_level/rel_bpm);
  //}
  //console.log('advanceOntimes:');
  //console.log(c.advanceOntimes);
  //console.log('advanceOnsets:');
  //console.log(c.advanceOnsets);
  //// This is for the visualisation.
  //for (j = 0; j < c.advanceOnsets.length; j++){
  //  Tone.Transport.setTimeout(function(){
  //    vocalCursorTop +=5;
  //    vocalCursor.css({top:vocalCursorTop+(vocalCursorTop?'px':'')});
  //  }, c.advanceOnsets[j]);
  //}
  
  var unq_samples = {};
  var notes = tonejs_scores[v.value].notes;
  console.log('notes:');
  console.log(notes);
  for (i = 0; i < notes.length; i++){
    if (unq_samples[notes[i][1]] == undefined){
      unq_samples[notes[i][1]] = piano_1.samples[notes[i][1]];
    }
  }
  console.log('unq_samples:');
  console.log(unq_samples);
  
  var Piano_1 = new Tone.PolySynth(10, Tone.Sampler,
    unq_samples,
    piano_1.volEnvEtc).toMaster();
  console.log('Piano_1:');
  console.log(Piano_1);
  
  Tone.Note.route("Piano_1", function(time, note, duration, velocity){
    Piano_1.triggerAttackRelease(note, duration, time, velocity);
  });
  
  // Parse the Score.
  var Score = { "Piano_1": notes };
  Tone.Note.parseScore(Score);
  Tone.Transport.bpm.value = 120;
  // Tone.Transport.loop = true;
  // Tone.Transport.setLoopPoints(0, "3m");
  
  // Time the loading of the audio material into the Tone.Buffer.
  var t0 = new Date();
  // var t0 = Math.round(+new Date()/1000);
  console.log('t0:');
  console.log(Math.round(t0));
  Tone.Buffer.onload = function(){
    var t1 = (new Date() - t0)/1000;
    console.log('Loading the audio material into the buffer took:');
    console.log(t1 + ' sec.');
    var lt = document.getElementById("loadTime");
    lt.value = t1;
  };
  // console.log('Tone.Buffer._queue:');
  // console.log(Tone.Buffer._queue);
  
  
});
